// NX

#ifndef IG_MODULE_CLASS_LONG_STRING_AS
#define IG_MODULE_CLASS_LONG_STRING_AS

#module MCLongString mString, mStrlen, mStrSize, mExpand

#define BufSize_Default 4096

// @ ̃obt@AKXLȂ炽̕mۂB

//##########################################################
//        \zE
//##########################################################
//------------------------------------------------
// [i] \z
//------------------------------------------------
#define global LongStr_new(%1, %2 = 0, %3 = 0) newmod %1, MCLongString@, %2, %3
#modinit int p2, int p3,  local defsize, local expandSize
	if ( p2 <= 0 ) { defsize = BufSize_Default } else { defsize = p2 }
	if ( p3 <= 0 ) { mExpand = BufSize_Default } else { mExpand = p3 }
	
	sdim mString, defsize
	mStrlen  = 0
	mStrSize = defsize
	return
	
//------------------------------------------------
// [i] 
//------------------------------------------------
#define global LongStr_delete(%1) delmod %1

//##########################################################
//        J\bh
//##########################################################
//------------------------------------------------
// ݒ肷
//------------------------------------------------
#modfunc LongStr_set str string
	LongStr_clear thismod
	LongStr_add   thismod, string
	return
	
//------------------------------------------------
// ɒǉ
//------------------------------------------------
#modfunc LongStr_add str src, int _lenToAppend
	// local tmpLen
	if ( _lenToAppend ) { tmpLen = _lenToAppend } else { tmpLen = strlen(src) }
	
	// overflow Ȃ悤
	if ( mStrSize <= mStrlen + tmpLen ) {
		LongStr_expand thismod, tmpLen
	}
	
	// 
	poke mString, mStrlen, src
	mStrlen += strsize
	assert (strsize == tmpLen)
	return
	
#modfunc LongStr_addv var src, int _lenToAppend
	if ( _lenToAppend ) { tmpLen = _lenToAppend } else { tmpLen = strlen(src) }
	
	if ( mStrSize <= mStrlen + tmpLen ) {
		LongStr_expand thismod, tmpLen
	}
	
	// 
	memcpy mString, src, tmpLen, mStrlen
	mStrlen += tmpLen
	poke mString, mStrlen
	return
	
#define global LongStr_cat       LongStr_add
#define global LongStr_push_back LongStr_add

// Ōɒǉꂽ̒
#defcfunc LongStr_lengthLastAddition
	return tmpLen

//------------------------------------------------
// A
//------------------------------------------------
#modfunc LongStr_addchar int c
	if ( c == 0 ) { return }
	
	// over-flow Ȃ悤
	if ( mStrSize <= mStrlen + 1 ) {
		LongStr_expand thismod, 1
	}
	
	// 
	wpoke mString, mStrlen, c
	mStrlen ++
	return
	
//------------------------------------------------
// 납
//------------------------------------------------
#modfunc LongStr_erase_back int sizeErase
	if ( sizeErase <= 0 ) { return }
	
	mStrlen -= sizeErase
	if ( mStrlen < 0 ) { mStrlen = 0 }
	
	// I[u
	poke mString, mStrlen, 0
	
	return
	
//------------------------------------------------
// obt@mۂ
//------------------------------------------------
#modfunc LongStr_reserve int size
	if ( mStrSize < size ) {
		mStrSize = size + mExpand
		memexpand mString, mStrSize
	}
	return
	
#modfunc LongStr_expand int size
	mStrSize += size + mExpand
	memexpand mString, mStrSize
	return
	
//------------------------------------------------
// ϐobt@ɕʂ
//------------------------------------------------
#modfunc LongStr_tobuf var buf
	if ( vartype( buf ) != vartype("str") ) {
		sdim      buf, mStrlen + 1
	} else {
		memexpand buf, mStrlen + 1
	}
	memcpy buf, mString, mStrlen + 1
	return
	
//##########################################################
//        擾n
//##########################################################
//------------------------------------------------
// [i] ̒Ԃ
//------------------------------------------------
#modcfunc LongStr_length
	return mStrlen
	
#define global LongStr_empty LongStr_length
#define global LongStr_size  LongStr_length
#define global LongStr_count LongStr_length

//------------------------------------------------
// mۍς݃obt@̑傫Ԃ
//------------------------------------------------
#modcfunc LongStr_bufSize
	return mStrSize
	
//------------------------------------------------
// ֐`ŕԂ(񐄏)
//------------------------------------------------
#modcfunc LongStr_get
	return mString
	
#modcfunc LongStr_dataPtr
	return varptr(mString)
	
//##########################################################
//        ֐
//##########################################################
//------------------------------------------------
// [i] 
//------------------------------------------------
#modfunc LongStr_clear
;	memset mString, 0, mStrlen
	poke mString
	mStrlen = 0
	return
	
//------------------------------------------------
// [i] A
//------------------------------------------------
#modfunc LongStr_chain var mv_from,  local data, local len
	len = LongStr_length(mv_from)
	dupptr data, LongStr_dataPtr(mv_from), len + 1, vartype("str")
	LongStr_addv thismod, data, len
	return
	
//------------------------------------------------
// [i] 
//------------------------------------------------
#modfunc LongStr_copy var mv_from
	LongStr_clear thismod
	LongStr_chain thismod, mv_from
	return
	
//------------------------------------------------
// [i] Rei
//------------------------------------------------
#modfunc LongStr_exchange var mv2, local mvTemp
	LongStr_new  mvTemp
	LongStr_copy mvTemp,  thismod
	LongStr_copy thismod, mv2
	LongStr_copy mv2,     mvTemp
	LongStr_delete mvTemp
	return
	
//##########################################################
//        \bh
//##########################################################

#global

#endif
